#!/usr/bin/python2.2
#^--- change the above line to point to your installation of Python


# $Id: //guest/mitch_stuart/perforce/utils/delta/p4DeltaGui.py#1 $


import re

from wxPython.wx import *
from wxPython.lib.rcsizer import RowColSizer

import p4Delta
from p4DirDialog import p4DirDialog
from p4DirSpecQualDialog import p4DirSpecQualDialog
import p4Util
import wxUtil


class p4DeltaGuiApp(wxApp):
   def OnInit(self):
      #wxInitAllImageHandlers()
      self.mainFrame = p4DeltaGuiFrame(None, -1)
      self.p4DeltaGuiPanel = p4DeltaGuiPanel(self.mainFrame, -1)
      self.SetTopWindow(self.mainFrame)
      self.mainFrame.Show(true)
      return True




class p4DeltaGuiFrame(wxFrame):
   def __init__(self, parent, id):
      wxFrame.__init__(self, parent, -1, "p4DeltaGui", size=(600, 580),
         style=wxDEFAULT_FRAME_STYLE | wxNO_FULL_REPAINT_ON_RESIZE)




class p4DeltaGuiPanel(wxPanel):
   def __init__(self, parent, id):

      wxPanel.__init__(self, parent, id)

      self.dirSelectDialog = None

      self.colorDisabledTextField = wxColour(240, 240, 240)

      self.textDir1 = wxTextCtrl(self, -1, "//depot")

      self.buttonDir1 = wxButton(self, -1, "Select...")
      self.buttonDir1.textField = self.textDir1

      self.textFilespec1 = wxTextCtrl(self, -1, "...")

      self.buttonQual1 = wxButton(self, -1, "Select...")
      self.buttonQual1.textField = self.textFilespec1

      self.radioDir2Same = wxRadioButton(self, -1, "Same as Dir 1",
         style = wxRB_GROUP)
      self.radioDir2Other = wxRadioButton(self, -1, "Other Dir: ")
      self.dir2Radios = [self.radioDir2Same, self.radioDir2Other]

      self.textDir2 = wxTextCtrl(self, -1, "//depot")

      self.buttonDir2 = wxButton(self, -1, "Select...")
      self.buttonDir2.textField = self.textDir2

      self.textFilespec2 = wxTextCtrl(self, -1, "...")

      self.buttonQual2 = wxButton(self, -1, "Select...")
      self.buttonQual2.textField = self.textFilespec2

      self.buttonDelta = wxButton(self, -1, "Delta")
      self.buttonExit = wxButton(self, -1, "Exit")

      self.textResults = wxTextCtrl(self, -1, "",
         style=wxTE_MULTILINE | wxTE_READONLY)

      self.enableTextField(self.textResults, false)


      sizer = RowColSizer()

      row = 0

      row += 1
      sizer.Add(wxStaticText(self, -1, "Dir 1"), pos=(row, 1))
      rowSizer = wxBoxSizer(wxHORIZONTAL)
      rowSizer.Add(self.textDir1, 1, wxEXPAND)
      rowSizer.Add(self.buttonDir1, 0, wxLEFT, 4)
      sizer.Add(rowSizer, flag=wxEXPAND | wxBOTTOM, border=8, pos=(row, 3))

      sizer.AddGrowableCol(3)

      row += 1
      sizer.Add(wxStaticText(self, -1, "Filespec 1"), pos=(row, 1))
      rowSizer = wxBoxSizer(wxHORIZONTAL)
      rowSizer.Add(self.textFilespec1, 1, wxEXPAND)
      rowSizer.Add(self.buttonQual1, 0, wxLEFT, 4)
      sizer.Add(rowSizer, flag=wxEXPAND | wxBOTTOM, border=8, pos=(row, 3))

      row += 1
      sizer.Add(wxStaticText(self, -1, "Dir 2"), pos=(row, 1))
      dir2Sizer = wxFlexGridSizer(0, 3, 8, 8)  # rows, cols, hgap, vgap
      dir2Sizer.AddMany([self.radioDir2Same,
         (0, 0),
         (0, 0),
         self.radioDir2Other,
         (self.textDir2, 0, wxEXPAND),
         self.buttonDir2])
      dir2Sizer.AddGrowableCol(1)
      sizer.Add(dir2Sizer, flag=wxEXPAND | wxBOTTOM, border=8, pos=(row, 3))

      row += 1
      sizer.Add(wxStaticText(self, -1, "Filespec 2"), pos=(row, 1))
      rowSizer = wxBoxSizer(wxHORIZONTAL)
      rowSizer.Add(self.textFilespec2, 1, wxEXPAND)
      rowSizer.Add(self.buttonQual2, 0, wxLEFT, 4)
      sizer.Add(rowSizer, flag=wxEXPAND | wxBOTTOM, border=8, pos=(row, 3))

      row += 1
      buttonSizer = wxBoxSizer(wxHORIZONTAL)
      buttonSizer.AddMany([self.buttonDelta, self.buttonExit])
      sizer.Add(buttonSizer, flag=wxALIGN_CENTER | wxBOTTOM, border=8,
         colspan=4, pos=(row, 1))

      row +=1
      sizer.Add(wxStaticText(self, -1, "Results"), pos=(row, 1))
      sizer.Add(self.textResults, flag=wxEXPAND, pos=(row, 3))
      sizer.AddGrowableRow(row)

      row += 1
      sizer.AddSpacer(-1, 10, pos=(row, 1))

      self.SetSizer(sizer)
      sizer.Fit(self)


      EVT_TEXT(self, self.textDir2.GetId(), self.onDir2Modified)

      EVT_BUTTON(self, self.buttonDir1.GetId(), self.onButtonDir)
      EVT_BUTTON(self, self.buttonDir2.GetId(), self.onButtonDir)


      EVT_BUTTON(self, self.buttonQual1.GetId(), self.onButtonQual)
      EVT_BUTTON(self, self.buttonQual2.GetId(), self.onButtonQual)

      EVT_BUTTON(self, self.buttonDelta.GetId(), self.onButtonDelta)
      EVT_BUTTON(self, self.buttonExit.GetId(), self.onButtonExit)


   def enableTextField(self, field, enable):
      if enable:
         bgcolor = wxWHITE
      else:
         bgcolor = self.colorDisabledTextField

      field.SetEditable(enable) 
      field.SetBackgroundColour(bgcolor)
      field.Refresh()


   def onDir2Modified(self, event):
      wxUtil.checkOneRadio(self.dir2Radios, self.radioDir2Other)


   def onButtonQual(self, event):
      dir = self.getDirForQualButton(event.GetEventObject())

      errmsg = None

      if len(dir) == 0:
         errmsg = "Please specify a Directory"

      try:
         p4Util.checkDirectoryExists(dir)
      except p4Util.p4Exception, errmsg:
         pass

      if not errmsg == None:
         errDialog = wxMessageDialog(self, str(errmsg), "Error", wxICON_ERROR)
         errDialog.Center()
         errDialog.ShowModal()
         return

      spec = self.getSpecWithoutQual(
         event.GetEventObject().textField.GetValue())

      path = dir

      if len(path) > 0:
         path = path + "/" + spec

      dialog = p4DirSpecQualDialog(path, self.GetParent(), -1)
      retval = dialog.ShowModal()

      if retval == wxID_OK:
         textField = event.GetEventObject().textField

         # Remove the current qualifier, if any, from the filespec
         text = textField.GetValue()
         text = self.getSpecWithoutQual(text)

         # Append the new qualifier to the filespec
         text = text + dialog.getQualifier()
         textField.SetValue(text)


   def onButtonDir(self, event):
      if self.dirSelectDialog == None:
         self.dirSelectDialog = p4DirDialog("//depot", self.GetParent(), -1)

      retval = self.dirSelectDialog.ShowModal()

      if retval == wxID_OK:
         selectedFullPath = self.dirSelectDialog.getSelectedFullPath()
         # print "Selected: %s" % selectedFullPath
         textField = event.GetEventObject().textField
         textField.SetValue(selectedFullPath)


   def onButtonExit(self, event):
      self.GetParent().Close()


   def getDirForQualButton(self, button):
      if button == self.buttonQual1:
         return self.textDir1.GetValue()
      else:
         return self.getDir2()


   def getDir2(self):
      if self.radioDir2Same.GetValue():
         return self.textDir1.GetValue()
      else:
         return self.textDir2.GetValue()


   def getSpecWithoutQual(self, spec):
      spec = re.sub("[@|#].*$", "", spec)
      return spec


   def onButtonDelta(self, event):
      dirspecs = [self.textDir1.GetValue(), self.getDir2()]
      filespecs = [self.textFilespec1.GetValue(), self.textFilespec2.GetValue()]
      # print dirspecs, filespecs

      try:
         wxBeginBusyCursor()

         try:
            deltaResults = p4Delta.computeFilesetDelta(dirspecs, filespecs)
            self.emitResults(deltaResults)
      
         except p4Util.p4Exception, errmsg:
            errDialog = wxMessageDialog(self, str(errmsg), "Error", wxICON_ERROR)
            errDialog.Center()
            errDialog.ShowModal()

      finally:
         wxEndBusyCursor()


   def emitResults(self, deltaResults):

      self.textResults.Clear()

      if deltaResults == None:
         print "No results"
         return
   
      headings = ("Removed Files", "Added Files", "Updated Files")
   
      for i in range(len(deltaResults)):
   
         if len(deltaResults[i]) > 0:
   
            self.textResults.AppendText("%s:\n" % headings[i])
   
            deltaResults[i].sort()
       
            for file in deltaResults[i]:
               self.textResults.AppendText("  %s\n" % file)
       
            self.textResults.AppendText("\n")  # blank line between sections




def main():
   app = p4DeltaGuiApp(0)
   app.MainLoop()

if __name__ == '__main__':
   main()
    

